function [R_0_BR3_CG,R_0_BR2_CG,R_0_BRS_CG, ...
          R_0_BL3_CG,R_0_BL2_CG,R_0_BLS_CG, ...
          R_0_W_CG,R_0_CG,R_0_CGCTR_CG]= ...
      CG_calc(R_0_JR3,R_0_JR2,R_0_JR1,R_0_JL3,R_0_JL2,R_0_JL1,robot_para,set_para,RL)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%CG_calc.m
%Kvv_Ng MATLAB
%S̏dŠvZ
%͈
%R_0_JR3:֐JR3E̍W[x,y,z]'[mm]
%R_0_JR2:֐JR2E̍W[x,y,z]'[mm]
%R_0_JR1:֐JR1E̍W[x,y,z]'[mm]
%R_0_JL3:֐JL3̍W[x,y,z]'[mm]
%R_0_JL2:֐JL2̍W[x,y,z]'[mm]
%R_0_JL1:֐JL1̍W[x,y,z]'[mm]
%robot_para:{bgp[^̍\
%set_para:ݒp[^̍\
%RL 'R':E쎞@'L':쎞
%o͈
%\
%o
%R_0_BR3_CG:N3EdSW[x,y,z]'[mm]
%R_0_BR2_CG:N2EdSW[x,y,z]'[mm]
%R_0_BRS_CG:EdSW[x,y,z]'[mm]
%R_0_BL3_CG:N3dSW[x,y,z]'[mm]
%R_0_BL2_CG:N2dSW[x,y,z]'[mm]
%R_0_BLS_CG:dSW[x,y,z]'[mm]
%R_0_W_CG:dSW[x,y,z]'[mm]
%R_0_CG:S̏dSW[x,y,z]'[mm]
%R_0_CGCTR_CG:dS⏞dSW[x,y,z]'[mm]
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Copyright (C) 2007 CYBERNET SYSTEMS CO.,LTD. All rights reserved.
%Version 1.0 2007/02/05 Hiroumi Mita
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%eidSWvZ
%E@N3
R_0_BR3_CG.x=(R_0_JR3.x+R_0_JR2.x)/2;
R_0_BR3_CG.y=(R_0_JR3.y+R_0_JR2.y)/2;
R_0_BR3_CG.z=(R_0_JR3.z+R_0_JR2.z)/2;
%E@N2
R_0_BR2_CG.x=(R_0_JR2.x+R_0_JR1.x)/2;
R_0_BR2_CG.y=(R_0_JR2.y+R_0_JR1.y)/2;
R_0_BR2_CG.z=(R_0_JR2.z+R_0_JR1.z)/2;
%E@
R_0_BRS_CG.x=R_0_JR1.x;
R_0_BRS_CG.y=R_0_JR1.y;
R_0_BRS_CG.z=R_0_JR1.z;

%@N3
R_0_BL3_CG.x=(R_0_JL3.x+R_0_JL2.x)/2;
R_0_BL3_CG.y=(R_0_JL3.y+R_0_JL2.y)/2;
R_0_BL3_CG.z=(R_0_JL3.z+R_0_JL2.z)/2;
%@N2
R_0_BL2_CG.x=(R_0_JL2.x+R_0_JL1.x)/2;
R_0_BL2_CG.y=(R_0_JL2.y+R_0_JL1.y)/2;
R_0_BL2_CG.z=(R_0_JL2.z+R_0_JL1.z)/2;
%@
R_0_BLS_CG.x=R_0_JL1.x;
R_0_BLS_CG.y=R_0_JL1.y;
R_0_BLS_CG.z=R_0_JL1.z;

%
R_0_W_CG.x=(R_0_JR3.x+R_0_JL3.x)/2;
R_0_W_CG.y=(R_0_JR3.y+R_0_JL3.y)/2;
R_0_W_CG.z=(R_0_JR3.z+R_0_JL3.z)/2;

M_s=robot_para.M_s;%s1_R,s1_L@[kg]
M_l23=robot_para.M_l23;%s1_R,s1_L [kg]
M_w=robot_para.M_w;%w [kg]

%dS⏞L̎
if(set_para.CGCTR_Enable==1)
    %dS⏞́A̍E[ړB
    %xW
    R_0_CGCTR_CG.x=R_0_W_CG.x;

    %yW
    %E@Œ̏ꍇAdS⏞͍Ɉړ
    if(RL=='R')
    R_0_CGCTR_CG.y=robot_para.w/2;
    end
    %@EŒ̏ꍇAdS⏞͉EɈړ
    if(RL=='L')
    R_0_CGCTR_CG.y=-robot_para.w/2;
    end

    %zW
    R_0_CGCTR_CG.z=R_0_W_CG.z+robot_para.r_CGCTR/2;
    %
    M_CGCTR=robot_para.M_CGCTR;

    %S̎[kg]
    M=M_s*2+M_l23*4+M_w+M_CGCTR;

    %S̏dSW[mm]
    %xW
    R_0_CG.x=(R_0_BR3_CG.x*M_l23+R_0_BR2_CG.x*M_l23+R_0_BRS_CG.x*M_s+ ...
        R_0_BL3_CG.x*M_l23+R_0_BL2_CG.x*M_l23+R_0_BLS_CG.x*M_s+ ...
        R_0_W_CG.x*M_w+R_0_CGCTR_CG.x*M_CGCTR)/M;
    %yW
    R_0_CG.y=(R_0_BR3_CG.y*M_l23+R_0_BR2_CG.y*M_l23+R_0_BRS_CG.y*M_s+ ...
        R_0_BL3_CG.y*M_l23+R_0_BL2_CG.y*M_l23+R_0_BLS_CG.y*M_s+ ...
        R_0_W_CG.y*M_w+R_0_CGCTR_CG.y*M_CGCTR)/M;
    %zW
    R_0_CG.z=(R_0_BR3_CG.z*M_l23+R_0_BR2_CG.z*M_l23+R_0_BRS_CG.z*M_s+ ...
        R_0_BL3_CG.z*M_l23+R_0_BL2_CG.z*M_l23+R_0_BLS_CG.z*M_s+ ...
        R_0_W_CG.z*M_w+R_0_CGCTR_CG.z*M_CGCTR)/M;
else
%dS⏞햳̎
    R_0_CGCTR_CG.x=0;
    R_0_CGCTR_CG.y=0;
    R_0_CGCTR_CG.z=0;
    R_0_CG.x=0;
    R_0_CG.y=0;
    R_0_CG.z=0;
end
