function [R_0_BR3_CG,R_0_BR2_CG,R_0_BRS_CG, ...
          R_0_BL3_CG,R_0_BL2_CG,R_0_BLS_CG, ...
          R_0_W_CG]= ...
          Vel_Acc_calc_forward(ii,R_0_BR3_CG,R_0_BR2_CG,R_0_BRS_CG, ...
                      R_0_BL3_CG,R_0_BL2_CG,R_0_BLS_CG, ...
                      R_0_W_CG,walk_para)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Vel_Acc_calc_forward.m
%Kvv_Ng MATLAB
%͈
% ii:CfbNX
%R_0_BR3_CG:[hW猩R3̏dSWx,y,z[mm]
%R_0_BR2_CG:[hW猩R2̏dSWx,y,z[mm]
%R_0_BRS_CG:[hW猩RS̏dSWx,y,z[mm]
%R_0_BL3_CG:[hW猩L3̏dSWx,y,z[mm]
%R_0_BL2_CG:[hW猩L2̏dSWx,y,z[mm]
%R_0_BLS_CG:[hW猩LS̏dSWx,y,z[mm]
%R_0_W_CG:[hW猩W̏dSWx,y,z[mm]
%walk_para:Op[^̍\
%o͈
%\
%o
%R_0_BR3_CG,R_0_BR2_CG,R_0_BRS_CG
%R_0_BL3_CG,R_0_BL2_CG,R_0_BLS_CG,R_0_W_CG
%Lɑxthetadot[rad/s]ǉ
%Lɉxtheta2dot[rad/s2]ǉ
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Copyright (C) 2007 CYBERNET SYSTEMS CO.,LTD. All rights reserved.
%Verison 1.0 2007/02/05 Hiroumi Mita
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Ts=walk_para.Ts;%Tv

%[Nϐ
con1=0;
con2=0;
con3=0;
con4=0;

if ii==1
    %TvOԍn=1̂Ƃ
    %xvZ
    R_0_BR3_CG(ii).x2dot=R_0_BR3_CG(ii).x/(Ts^2);
    R_0_BR2_CG(ii).x2dot=R_0_BR2_CG(ii).x/(Ts^2);
    R_0_BRS_CG(ii).x2dot=R_0_BRS_CG(ii).x/(Ts^2);
    R_0_BL3_CG(ii).x2dot=R_0_BL3_CG(ii).x/(Ts^2);
    R_0_BL2_CG(ii).x2dot=R_0_BL2_CG(ii).x/(Ts^2);
    R_0_BLS_CG(ii).x2dot=R_0_BLS_CG(ii).x/(Ts^2);
    R_0_W_CG(ii).x2dot=R_0_W_CG(ii).x/(Ts^2);

    R_0_BR3_CG(ii).y2dot=R_0_BR3_CG(ii).y/(Ts^2);
    R_0_BR2_CG(ii).y2dot=R_0_BR2_CG(ii).y/(Ts^2);
    R_0_BRS_CG(ii).y2dot=R_0_BRS_CG(ii).y/(Ts^2);
    R_0_BL3_CG(ii).y2dot=R_0_BL3_CG(ii).y/(Ts^2);
    R_0_BL2_CG(ii).y2dot=R_0_BL2_CG(ii).y/(Ts^2);
    R_0_BLS_CG(ii).y2dot=R_0_BLS_CG(ii).y/(Ts^2);
    R_0_W_CG(ii).y2dot=R_0_W_CG(ii).y/(Ts^2);

    R_0_BR3_CG(ii).z2dot=R_0_BR3_CG(ii).z/(Ts^2);
    R_0_BR2_CG(ii).z2dot=R_0_BR2_CG(ii).z/(Ts^2);
    R_0_BRS_CG(ii).z2dot=R_0_BRS_CG(ii).z/(Ts^2);
    R_0_BL3_CG(ii).z2dot=R_0_BL3_CG(ii).z/(Ts^2);
    R_0_BL2_CG(ii).z2dot=R_0_BL2_CG(ii).z/(Ts^2);
    R_0_BLS_CG(ii).z2dot=R_0_BLS_CG(ii).z/(Ts^2);
    R_0_W_CG(ii).z2dot=R_0_W_CG(ii).z/(Ts^2);
    
    %xvZ
    R_0_BR3_CG(ii).xdot=R_0_BR3_CG(ii).x/Ts;
    R_0_BR2_CG(ii).xdot=R_0_BR2_CG(ii).x/Ts;
    R_0_BRS_CG(ii).xdot=R_0_BRS_CG(ii).x/Ts;
    R_0_BL3_CG(ii).xdot=R_0_BL3_CG(ii).x/Ts;
    R_0_BL2_CG(ii).xdot=R_0_BL2_CG(ii).x/Ts;
    R_0_BLS_CG(ii).xdot=R_0_BLS_CG(ii).x/Ts;
    R_0_W_CG(ii).xdot=R_0_W_CG(ii).x/Ts;

    R_0_BR3_CG(ii).ydot=R_0_BR3_CG(ii).y/Ts;
    R_0_BR2_CG(ii).ydot=R_0_BR2_CG(ii).y/Ts;
    R_0_BRS_CG(ii).ydot=R_0_BRS_CG(ii).y/Ts;
    R_0_BL3_CG(ii).ydot=R_0_BL3_CG(ii).y/Ts;
    R_0_BL2_CG(ii).ydot=R_0_BL2_CG(ii).y/Ts;
    R_0_BLS_CG(ii).ydot=R_0_BLS_CG(ii).y/Ts;
    R_0_W_CG(ii).ydot=R_0_W_CG(ii).y/Ts;

    R_0_BR3_CG(ii).zdot=R_0_BR3_CG(ii).z/Ts;
    R_0_BR2_CG(ii).zdot=R_0_BR2_CG(ii).z/Ts;
    R_0_BRS_CG(ii).zdot=R_0_BRS_CG(ii).z/Ts;
    R_0_BL3_CG(ii).zdot=R_0_BL3_CG(ii).z/Ts;
    R_0_BL2_CG(ii).zdot=R_0_BL2_CG(ii).z/Ts;
    R_0_BLS_CG(ii).zdot=R_0_BLS_CG(ii).z/Ts;
    R_0_W_CG(ii).zdot=R_0_W_CG(ii).z/Ts;

end

%n>=2 sKvZl@
if(ii>=2)
    %En@ZWl0Ol0łȂ
    con1=(R_0_BRS_CG(ii).z==0) &&(R_0_BRS_CG(ii-1).z~=0);
    %n@ZWl0Ol0łȂ
    con2=(R_0_BLS_CG(ii).z==0) &&(R_0_BLS_CG(ii-1).z~=0);
end

if(ii>=3)
   %ؑց@EZWl0Ol0OXl0łȂ
    con3=(R_0_BRS_CG(ii).z==0)&&(R_0_BRS_CG(ii-1).z==0)&&(R_0_BRS_CG(ii-2).z~=0);
   %ؑց@ZWl0Ol0OXl0łȂ
    con4=(R_0_BLS_CG(ii).z==0)&&(R_0_BLS_CG(ii-1).z==0)&&(R_0_BLS_CG(ii-2).z~=0);
end

if(ii>=2)&&(con1||con2||con3||con4)
    abn_flag=1;%ُl
else 
abn_flag=0;%l
end    

if (ii>=2)&&(ii<=length(R_0_BR3_CG)-1)&&abn_flag==0
    %TvOԍn>=2n<=length(R_0_BR3_CG)-1
    %ُltOOFF̂Ƃ
    %xvZ
    R_0_BR3_CG(ii).x2dot=(R_0_BR3_CG(ii+1).x-2*R_0_BR3_CG(ii).x+R_0_BR3_CG(ii-1).x)/(Ts^2);
    R_0_BR2_CG(ii).x2dot=(R_0_BR2_CG(ii+1).x-2*R_0_BR2_CG(ii).x+R_0_BR2_CG(ii-1).x)/(Ts^2);
    R_0_BRS_CG(ii).x2dot=(R_0_BRS_CG(ii+1).x-2*R_0_BRS_CG(ii).x+R_0_BRS_CG(ii-1).x)/(Ts^2);
    R_0_BL3_CG(ii).x2dot=(R_0_BL3_CG(ii+1).x-2*R_0_BL3_CG(ii).x+R_0_BL3_CG(ii-1).x)/(Ts^2);
    R_0_BL2_CG(ii).x2dot=(R_0_BL2_CG(ii+1).x-2*R_0_BL2_CG(ii).x+R_0_BL2_CG(ii-1).x)/(Ts^2);
    R_0_BLS_CG(ii).x2dot=(R_0_BLS_CG(ii+1).x-2*R_0_BLS_CG(ii).x+R_0_BLS_CG(ii-1).x)/(Ts^2);
      R_0_W_CG(ii).x2dot=  (R_0_W_CG(ii+1).x-2*  R_0_W_CG(ii).x+  R_0_W_CG(ii-1).x)/(Ts^2);
    
    R_0_BR3_CG(ii).y2dot=(R_0_BR3_CG(ii+1).y-2*R_0_BR3_CG(ii).y+R_0_BR3_CG(ii-1).y)/(Ts^2);
    R_0_BR2_CG(ii).y2dot=(R_0_BR2_CG(ii+1).y-2*R_0_BR2_CG(ii).y+R_0_BR2_CG(ii-1).y)/(Ts^2);
    R_0_BRS_CG(ii).y2dot=(R_0_BRS_CG(ii+1).y-2*R_0_BRS_CG(ii).y+R_0_BRS_CG(ii-1).y)/(Ts^2);
    R_0_BL3_CG(ii).y2dot=(R_0_BL3_CG(ii+1).y-2*R_0_BL3_CG(ii).y+R_0_BL3_CG(ii-1).y)/(Ts^2);
    R_0_BL2_CG(ii).y2dot=(R_0_BL2_CG(ii+1).y-2*R_0_BL2_CG(ii).y+R_0_BL2_CG(ii-1).y)/(Ts^2);
    R_0_BLS_CG(ii).y2dot=(R_0_BLS_CG(ii+1).y-2*R_0_BLS_CG(ii).y+R_0_BLS_CG(ii-1).y)/(Ts^2);
    R_0_W_CG(ii).y2dot=    (R_0_W_CG(ii+1).y-2*  R_0_W_CG(ii).y+  R_0_W_CG(ii-1).y)/(Ts^2);

    R_0_BR3_CG(ii).z2dot=(R_0_BR3_CG(ii+1).z-2*R_0_BR3_CG(ii).z+R_0_BR3_CG(ii-1).z)/(Ts^2);
    R_0_BR2_CG(ii).z2dot=(R_0_BR2_CG(ii+1).z-2*R_0_BR2_CG(ii).z+R_0_BR2_CG(ii-1).z)/(Ts^2);
    R_0_BRS_CG(ii).z2dot=(R_0_BRS_CG(ii+1).z-2*R_0_BRS_CG(ii).z+R_0_BRS_CG(ii-1).z)/(Ts^2);
    R_0_BL3_CG(ii).z2dot=(R_0_BL3_CG(ii+1).z-2*R_0_BL3_CG(ii).z+R_0_BL3_CG(ii-1).z)/(Ts^2);
    R_0_BL2_CG(ii).z2dot=(R_0_BL2_CG(ii+1).z-2*R_0_BL2_CG(ii).z+R_0_BL2_CG(ii-1).z)/(Ts^2);
    R_0_BLS_CG(ii).z2dot=(R_0_BLS_CG(ii+1).z-2*R_0_BLS_CG(ii).z+R_0_BLS_CG(ii-1).z)/(Ts^2);
      R_0_W_CG(ii).z2dot=  (R_0_W_CG(ii+1).z-  2*R_0_W_CG(ii).z+  R_0_W_CG(ii-1).z)/(Ts^2);

    %xvZ
    R_0_BR3_CG(ii).xdot=(R_0_BR3_CG(ii+1).x-R_0_BR3_CG(ii).x)/Ts;
    R_0_BR2_CG(ii).xdot=(R_0_BR2_CG(ii+1).x-R_0_BR2_CG(ii).x)/Ts;
    R_0_BRS_CG(ii).xdot=(R_0_BRS_CG(ii+1).x-R_0_BRS_CG(ii).x)/Ts;
    R_0_BL3_CG(ii).xdot=(R_0_BL3_CG(ii+1).x-R_0_BL3_CG(ii).x)/Ts;
    R_0_BL2_CG(ii).xdot=(R_0_BL2_CG(ii+1).x-R_0_BL2_CG(ii).x)/Ts;
    R_0_BLS_CG(ii).xdot=(R_0_BLS_CG(ii+1).x-R_0_BLS_CG(ii).x)/Ts;
      R_0_W_CG(ii).xdot=  (R_0_W_CG(ii+1).x-R_0_W_CG(ii).x)/Ts;
    
    R_0_BR3_CG(ii).ydot=(R_0_BR3_CG(ii+1).y-R_0_BR3_CG(ii).y)/Ts;
    R_0_BR2_CG(ii).ydot=(R_0_BR2_CG(ii+1).y-R_0_BR2_CG(ii).y)/Ts;
    R_0_BRS_CG(ii).ydot=(R_0_BRS_CG(ii+1).y-R_0_BRS_CG(ii).y)/Ts;
    R_0_BL3_CG(ii).ydot=(R_0_BL3_CG(ii+1).y-R_0_BL3_CG(ii).y)/Ts;
    R_0_BL2_CG(ii).ydot=(R_0_BL2_CG(ii+1).y-R_0_BL2_CG(ii).y)/Ts;
    R_0_BLS_CG(ii).ydot=(R_0_BLS_CG(ii+1).y-R_0_BLS_CG(ii).y)/Ts;
    R_0_W_CG(ii).ydot=    (R_0_W_CG(ii+1).y-R_0_W_CG(ii).y)/Ts;

    R_0_BR3_CG(ii).zdot=(R_0_BR3_CG(ii+1).z-R_0_BR3_CG(ii).z)/Ts;
    R_0_BR2_CG(ii).zdot=(R_0_BR2_CG(ii+1).z-R_0_BR2_CG(ii).z)/Ts;
    R_0_BRS_CG(ii).zdot=(R_0_BRS_CG(ii+1).z-R_0_BRS_CG(ii).z)/Ts;
    R_0_BL3_CG(ii).zdot=(R_0_BL3_CG(ii+1).z-R_0_BL3_CG(ii).z)/Ts;
    R_0_BL2_CG(ii).zdot=(R_0_BL2_CG(ii+1).z-R_0_BL2_CG(ii).z)/Ts;
    R_0_BLS_CG(ii).zdot=(R_0_BLS_CG(ii+1).z-R_0_BLS_CG(ii).z)/Ts;
      R_0_W_CG(ii).zdot=  (R_0_W_CG(ii+1).z-R_0_W_CG(ii).z)/Ts;

end    

if ii==length(R_0_BR3_CG) ||(abn_flag==1)
    %TvOԍn=end܂ُ͈ltOON̂ƂA1Õf[^ƓƂB
    %xvZ
    R_0_BR3_CG(ii).x2dot=R_0_BR3_CG(ii-1).x2dot;
    R_0_BR2_CG(ii).x2dot=R_0_BR2_CG(ii-1).x2dot;
    R_0_BRS_CG(ii).x2dot=R_0_BRS_CG(ii-1).x2dot;
    R_0_BL3_CG(ii).x2dot=R_0_BL3_CG(ii-1).x2dot;
    R_0_BL2_CG(ii).x2dot=R_0_BL2_CG(ii-1).x2dot;
    R_0_BLS_CG(ii).x2dot=R_0_BLS_CG(ii-1).x2dot;
    R_0_W_CG(ii).x2dot=R_0_W_CG(ii-1).x2dot;
    
    R_0_BR3_CG(ii).y2dot=R_0_BR3_CG(ii-1).y2dot;
    R_0_BR2_CG(ii).y2dot=R_0_BR2_CG(ii-1).y2dot;
    R_0_BRS_CG(ii).y2dot=R_0_BRS_CG(ii-1).y2dot;
    R_0_BL3_CG(ii).y2dot=R_0_BL3_CG(ii-1).y2dot;
    R_0_BL2_CG(ii).y2dot=R_0_BL2_CG(ii-1).y2dot;
    R_0_BLS_CG(ii).y2dot=R_0_BLS_CG(ii-1).y2dot;
    R_0_W_CG(ii).y2dot=R_0_W_CG(ii-1).y2dot;
    
    R_0_BR3_CG(ii).z2dot=R_0_BR3_CG(ii-1).z2dot;
    R_0_BR2_CG(ii).z2dot=R_0_BR2_CG(ii-1).z2dot;
    R_0_BRS_CG(ii).z2dot=R_0_BRS_CG(ii-1).z2dot;
    R_0_BL3_CG(ii).z2dot=R_0_BL3_CG(ii-1).z2dot;
    R_0_BL2_CG(ii).z2dot=R_0_BL2_CG(ii-1).z2dot;
    R_0_BLS_CG(ii).z2dot=R_0_BLS_CG(ii-1).z2dot;
    R_0_W_CG(ii).z2dot=R_0_W_CG(ii-1).z2dot;
    %xvZ
    R_0_BR3_CG(ii).xdot=R_0_BR3_CG(ii-1).xdot;
    R_0_BR2_CG(ii).xdot=R_0_BR2_CG(ii-1).xdot;
    R_0_BRS_CG(ii).xdot=R_0_BRS_CG(ii-1).xdot;
    R_0_BL3_CG(ii).xdot=R_0_BL3_CG(ii-1).xdot;
    R_0_BL2_CG(ii).xdot=R_0_BL2_CG(ii-1).xdot;
    R_0_BLS_CG(ii).xdot=R_0_BLS_CG(ii-1).xdot;
    R_0_W_CG(ii).xdot=R_0_W_CG(ii-1).xdot;
    
    R_0_BR3_CG(ii).ydot=R_0_BR3_CG(ii-1).ydot;
    R_0_BR2_CG(ii).ydot=R_0_BR2_CG(ii-1).ydot;
    R_0_BRS_CG(ii).ydot=R_0_BRS_CG(ii-1).ydot;
    R_0_BL3_CG(ii).ydot=R_0_BL3_CG(ii-1).ydot;
    R_0_BL2_CG(ii).ydot=R_0_BL2_CG(ii-1).ydot;
    R_0_BLS_CG(ii).ydot=R_0_BLS_CG(ii-1).ydot;
    R_0_W_CG(ii).ydot=R_0_W_CG(ii-1).ydot;
    
    R_0_BR3_CG(ii).zdot=R_0_BR3_CG(ii-1).zdot;
    R_0_BR2_CG(ii).zdot=R_0_BR2_CG(ii-1).zdot;
    R_0_BRS_CG(ii).zdot=R_0_BRS_CG(ii-1).zdot;
    R_0_BL3_CG(ii).zdot=R_0_BL3_CG(ii-1).zdot;
    R_0_BL2_CG(ii).zdot=R_0_BL2_CG(ii-1).zdot;
    R_0_BLS_CG(ii).zdot=R_0_BLS_CG(ii-1).zdot;
    R_0_W_CG(ii).zdot=R_0_W_CG(ii-1).zdot;
    
end

    %xvZ
    R_0_BR3_CG(ii).v=sqrt(R_0_BR3_CG(ii).xdot^2+R_0_BR3_CG(ii).zdot^2);
    R_0_BR2_CG(ii).v=sqrt(R_0_BR2_CG(ii).xdot^2+R_0_BR2_CG(ii).zdot^2);
    R_0_BRS_CG(ii).v=sqrt(R_0_BRS_CG(ii).xdot^2+R_0_BRS_CG(ii).zdot^2);
    R_0_BL3_CG(ii).v=sqrt(R_0_BL3_CG(ii).xdot^2+R_0_BL3_CG(ii).zdot^2);
    R_0_BL2_CG(ii).v=sqrt(R_0_BL2_CG(ii).xdot^2+R_0_BL2_CG(ii).zdot^2);
    R_0_BLS_CG(ii).v=sqrt(R_0_BLS_CG(ii).xdot^2+R_0_BLS_CG(ii).zdot^2);
    R_0_W_CG(ii).v=sqrt(R_0_W_CG(ii).xdot^2+R_0_W_CG(ii).zdot^2);

